package com.mygrouptasks.worksuggest.controller;

import com.mygrouptasks.worksuggest.entity.Person;
import com.mygrouptasks.worksuggest.entity.Task;
import com.mygrouptasks.worksuggest.entity.TaskStatus;
import com.mygrouptasks.worksuggest.repository.PersonRepository;
import com.mygrouptasks.worksuggest.repository.TaskRepository;
import com.mygrouptasks.worksuggest.service.PersonService;
import com.mygrouptasks.worksuggest.service.TaskService;
import com.mygrouptasks.worksuggest.service.TaskStatusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;

@Controller
public class ManyToManyController {

    @Autowired
    private TaskService taskService;

    @Autowired
    private TaskRepository taskRepository;

    @Autowired
    private PersonService personService;

    @Autowired
    private PersonRepository personRepository;

    @GetMapping("/many-to-many--from-task-side") //wrong because work happens on owning side,i.e. person side
        //but what if I want to get all tasks for one person or all persons for a task? check this.

    public String taskOps() {

        //see all tasks for a person, given the person


        //see all the persons given a task

        //add a person to task, see the relation happening in persons_tasks table
        int task_id = 2;
        Task task = taskService.getTask(task_id);

        int personToAdd_id = 3;
        System.out.println("- person to add id received: " + personToAdd_id);
        Person newPerson = personService.getPerson(personToAdd_id);
        System.out.println("- new person to add. Person's name: " + newPerson.getName());

        task.getPersons().add(newPerson);
        taskRepository.save(task);

        personToAdd_id = 4;
        System.out.println("- person to add id received: " + personToAdd_id);
        Person newPerson2 = personService.getPerson(personToAdd_id);
        System.out.println("- new person to add. Person's name: " + newPerson2.getName());

        task.getPersons().add(newPerson2);
        taskRepository.save(task);

        //newPerson.getTasks().add(task);
        //personRepository.save(newPerson);


        return "nocontent";
    }

    @GetMapping("/many-to-many--from-person-side")
    public String personOps() {

        //add a person to task, see the relation happening in persons_tasks table
        int personToAdd_id = 3;
        int task_id = 2;

        System.out.println("- person to add id received: " + personToAdd_id);
        Person newPerson = personService.getPerson(personToAdd_id);
        System.out.println("- new person to add. Person's name: " + newPerson.getName());
        Task task = taskService.getTask(task_id);
        newPerson.getTasks().add(task);
        personRepository.save(newPerson);

        //see all tasks for a person, given the person
        System.out.println("\n\n- get all tasks for a person...");
        System.out.println(newPerson.getTasks());

        //see all the persons given a task

        return "nocontent";
    }

}
